Init script does not create a PID file

33,678

Add the --make-pidfile option to your call of start-stop-daemon. --pidfile only tells start-stop-daemon where to look for the pidfile, without --make-pidfile it is assume that this pidfile is created by the program to be launched, and not by start-stop-daemon.

Be sure to read the manpage of start-stop-daemon(8) for more details.

Share:
33,678

Related videos on Youtube

Cory Walker
Author by

Cory Walker

I mainly use Linux (Ubuntu distro), I enjoy programming (C++, Java, PHP), and I love electronics, physics, and science. I am very involved in open source projects like iphonelinux and linux4nano. I also manage the NXT++ project on Sourceforge.

Updated on September 17, 2022

Comments

  • Cory Walker
    Cory Walker almost 2 years

    I need to create an init script for an IRC logger. I copied /etc/init.d/skeleton. I filled in the configuration section to fit my needs and I also had to add --background to the start daemon command since my IRC logger doesn't split off. The logger starts up fine when I use my init script, but it doesn't create the .pid file like it should. As a result the process cannot be stopped unless I find out the process ID myself and kill it. Here is the script:

    #! /bin/sh
    ### BEGIN INIT INFO
    # Provides:          skeleton
    # Required-Start:    $remote_fsh
    # Required-Stop:     $remote_fs
    # Default-Start:     2 3 4 5
    # Default-Stop:      0 1 6
    # Short-Description: Example initscript
    # Description:       This file should be used to construct scripts to be
    #                    placed in /etc/init.d.
    ### END INIT INFO
    
    # Author: Cory Walker <[email protected]>
    #
    # Please remove the "Author" lines above and replace them
    # with your own name if you copy and modify this script.
    
    # Do NOT "set -e"
    
    # PATH should only include /usr/* if it runs after the mountnfs.sh script
    PATH=/sbin:/usr/sbin:/bin:/usr/bin
    DESC="Logs specified IRC channels."
    NAME=irclogger
    DAEMON=/usr/sbin/$NAME
    #DAEMON_ARGS="irc.freenode.net linux4nano linux4nano-dev freemyipod freemyipod-dev"
    DAEMON_ARGS="irc.freenode.net blablabla"
    PIDFILE=/var/run/$NAME.pid
    SCRIPTNAME=/etc/init.d/$NAME
    
    # Exit if the package is not installed
    [ -x "$DAEMON" ] || exit 0
    
    # Read configuration variable file if it is present
    [ -r /etc/default/$NAME ] && . /etc/default/$NAME
    
    # Load the VERBOSE setting and other rcS variables
    . /lib/init/vars.sh
    
    # Define LSB log_* functions.
    # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
    . /lib/lsb/init-functions
    
    #
    # Function that starts the daemon/service
    #
    do_start()
    {
     # Return
     #   0 if daemon has been started
     #   1 if daemon was already running
     #   2 if daemon could not be started
     start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
      || return 1
     start-stop-daemon --start --background --pidfile $PIDFILE --exec $DAEMON -- \
      $DAEMON_ARGS \
      || return 2
     # Add code here, if necessary, that waits for the process to be ready
     # to handle requests from services started subsequently which depend
     # on this one.  As a last resort, sleep for some time.
    }
    
    #
    # Function that stops the daemon/service
    #
    do_stop()
    {
     # Return
     #   0 if daemon has been stopped
     #   1 if daemon was already stopped
     #   2 if daemon could not be stopped
     #   other if a failure occurred
     start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
     RETVAL="$?"
     [ "$RETVAL" = 2 ] && return 2
     # Wait for children to finish too if this is a daemon that forks
     # and if the daemon is only ever run from this initscript.
     # If the above conditions are not satisfied then add some other code
     # that waits for the process to drop all resources that could be
     # needed by services started subsequently.  A last resort is to
     # sleep for some time.
     start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
     [ "$?" = 2 ] && return 2
     # Many daemons don't delete their pidfiles when they exit.
     rm -f $PIDFILE
     return "$RETVAL"
    }
    
    #
    # Function that sends a SIGHUP to the daemon/service
    #
    do_reload() {
     #
     # If the daemon can reload its configuration without
     # restarting (for example, when it is sent a SIGHUP),
     # then implement that here.
     #
     start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
     return 0
    }
    
    case "$1" in
      start)
     [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
     do_start
     case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
     esac
     ;;
      stop)
     [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
     do_stop
     case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
     esac
     ;;
      #reload|force-reload)
     #
     # If do_reload() is not implemented then leave this commented out
     # and leave 'force-reload' as an alias for 'restart'.
     #
     #log_daemon_msg "Reloading $DESC" "$NAME"
     #do_reload
     #log_end_msg $?
     #;;
      restart|force-reload)
     #
     # If the "reload" option is implemented then remove the
     # 'force-reload' alias
     #
     log_daemon_msg "Restarting $DESC" "$NAME"
     do_stop
     case "$?" in
       0|1)
      do_start
      case "$?" in
       0) log_end_msg 0 ;;
       1) log_end_msg 1 ;; # Old process is still running
       *) log_end_msg 1 ;; # Failed to start
      esac
      ;;
       *)
        # Failed to stop
      log_end_msg 1
      ;;
     esac
     ;;
      *)
     #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
     echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
     exit 3
     ;;
    esac
    
    :
    
  • Cory Walker
    Cory Walker almost 14 years
    Haha that makes sense. I wonder why the skeleton init script that comes with Ubuntu doesn't have that though. Weird.